const connection = require("../../../config/database");
var asyncLoop = require("node-async-loop");
var GLOBAL = require("../../../config/constant");
var common = require("../../../config/common");
const { required } = require("../../../language/en");
const { request } = require("express");
var middleware = require("../../../middleware/validator");
const globals = require("../../../config/constant");
var emailTemplate = require("../../../config/template");

var auth = {
  // -----------------------SIGNUP---------------------------
  

  signup: function (request, callback) {
    auth.checkEmailUsed(request, function (isEmailUsed) {
      if (isEmailUsed) {
        callback(globals.OPRETION_FAILD, {
          keyword: "rest_keywords_unique_email_error",
          content: { name: request.name },
        });
      } else {
        auth.checkPhoneNumber(request, function (isPhoneNumberUsed) {
          if (isPhoneNumberUsed) {
            callback(globals.OPRETION_FAILD, {
              keyword: "rest_keywords_unique_phone_number_error",
              content: { name: request.name },
            });
          } else {
            //console.log("hello");
            middleware.encryption(request.password, function (enc_password) {
              var data = {
                name: request.name,
                country_code_id: request.country_code_id,
                phone_number: request.phone_number,
                email: request.email,
                password: enc_password,
              };
              //console.log(data);

              connection.query(
                "INSERT INTO tbl_user SET ?",
                data,
                function (error, newUser) {
                  if (!error) {
                    var device_data = {
                      user_id: newUser.insertId,
                      device_name: request.device_name,
                      device_token: request.device_token,
                      device_type: request.device_type,
                      os_version: request.os_version,
                      app_version: request.app_version,
                      token: common.generateToken(),
                    };
                    common.checkUpdateToken(device_data, function (response) {
                      if (response != null) {
                        var today = new Date();
                        var updatedata = {
                          is_online: "1",
                          last_login: today,
                        };
                        request.user_id = newUser.insertId;
                        auth.updateUser(
                          updatedata,
                          request,
                          function (updateddata) {
                            if (updateddata != null) {
                              auth.getUserDetails(
                                request,
                                function (code, message, userdetails) {
                                  if (userdetails) {
                                
                                    var otp = 1234;
                                    emailTemplate.emailVerifiedSuccess(
                                      otp,
                                      function (emailTemplateResult) {
                                        common.sendEmail(
                                          userdetails.userdetails.email,
                                          "Verifie Email otp",
                                          emailTemplateResult,
                                          function (isSend) {
                                            if (isSend) {
                                              updatedata = {
                                                otp: otp,
                                                email_verified: 1,
                                              };
                                              auth.updateUser(
                                                updatedata,
                                                userdetails.userdetails,
                                                function (isUpdated) {
                                                  if (isUpdated) {
                                                    callback(
                                                      globals.SUCCESS,
                                                      {
                                                        keyword:
                                                          "rest_keywords_success",
                                                        content: {},
                                                      },
                                                      userdetails
                                                    );
                                                  } else {
                                                    callback(
                                                      globals.OPRETION_FAILD,
                                                      {
                                                        keyword:
                                                          "rest_keywords_user_data_update_fail",
                                                        content: {},
                                                      },
                                                      false
                                                    );
                                                  }
                                                }
                                              );
                                            } else {
                                              callback(
                                                globals.OPRETION_FAILD,
                                                {
                                                  keyword:
                                                    "rest_keywords_failed_to_send_email",
                                                  content: {},
                                                },
                                                false
                                              );
                                            }
                                          }
                                        );
                                      }
                                    );
                                  } else {
                                    callback(
                                      globals.SUCCESS,
                                      {
                                        keyword: "rest_keyword_no_data",
                                        content: {},
                                      },
                                      null
                                    );
                                  }
                                }
                              );
                            } else {
                              callback(
                                globals.SUCCESS,
                                {
                                  keyword: "rest_keywords_something_went_wrong",
                                  content: {},
                                },
                                null
                              );
                            }
                          }
                        );
                      }
                    });
                  }
                }
              );
            });
          }
        });
      }
    });
  },

  // ==================== CHECK EMAIL USED ============================
  checkEmailUsed: function (request, callback) {
    // console.log("email------", request);
    connection.query(
      `select id,email from tbl_user where email = '${request.email}'`,
      function (error, result) {
        //console.log(this.sql);
        // console.log("result========>", result);
        if (!error && result.length > 0) {
          // console.log("123");
          callback(true);
        } else {
          callback(false);
        }
      }
    );
  },

  //==================== Check Phone Number ===========================
  checkPhoneNumber: function (request, callback) {
    // console.log("number", request);
    connection.query(
      `select id,country_code_id,phone_number from tbl_user where country_code_id='${request.country_code}' and phone_number='${request.phone_number}'`,
      function (error, result) {
        ///console.log(this.sql);
        //console.log("number------", result);
        if (!error && result.length > 0) {
          // console.log("123");
          callback(true);
        } else {
          //console.log("1111");
          callback(false);
        }
      }
    );
  },


  //====================== Get User Details ===============================
  getUserDetails: function (request, callback) {
    // console.log(request);
    connection.query(
      `SELECT id as user_id,name,email,country_code_id,phone_number,profile_image,login_type,notes,password,otp,social_id,is_forgot,last_login,email_verified FROM tbl_user WHERE is_active=1 and is_deleted=0 AND id=${request.user_id}`,
      function (err, userdetails) {
        if (!err && userdetails.length > 0) {
          auth.getDeviceDetails(
            request,
            function (code, message, devicedetails) {
              console.log("-----------", devicedetails, userdetails[0]);
              //  userdetails[0].devicedetails = devicedetails;
              if (devicedetails != null) {
                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_success", content: {} },
                  { userdetails: userdetails[0], devicedetails: devicedetails }
                );
              } else {
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },

  //======================= Get Device Data =============================
  getDeviceDetails: function (request, callback) {
    var userdata = `SELECT id,user_id,token,device_token FROM tbl_user_device WHERE user_id=?`;
    connection.query(
      userdata,
      [request.user_id],
      function (err, devicedetails) {
        if (!err && devicedetails.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keyword_no_data", content: {} },
            devicedetails[0]
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },

  // ----------------------LOGIN-----------------------------

login: function (request, callback) {
    //console.log("request", request.email);
    var enc_password = "";

    middleware.encryption(request.password, function (encryptedPassword) {
      enc_password = encryptedPassword;
      //console.log(enc_password);
      connection.query(
        `SELECT id as user_id,email,country_code_id,phone_number,password FROM tbl_user WHERE email='${request.email}' and (is_active=1 and is_deleted=0)`,
        function (err, userdata) {
          //console.log("hii", userdata);
          if (!err && userdata.length > 0) {
            //console.log("hello");
            if (userdata[0].password == enc_password) {
              var deviceinfo = {
                user_id: userdata[0].user_id,
                device_name: request.device_name,
                device_token: request.device_token,
                device_type: request.device_type,
                os_version: request.os_version,
                app_version: request.app_version,
                token: common.generateToken(),
              };
              //console.log(deviceinfo);
              common.checkUpdateToken(deviceinfo, function (response) {
                if (response == "") {
                  callback(
                    constant.OPRETION_FAILD,
                    {
                      keyword:
                        "rest_keyword_no_dataheader_authorization_token_error",
                      content: {},
                    },
                    {}
                  );
                } else {
                  auth.getUserDetails(
                    userdata[0],
                    function (code, message, userdetails) {
                      if (userdetails) {
                        var today = new Date();
                        updatedata = {
                          is_online: "1",
                          last_login: today,
                        };

                        auth.updateUser(
                          updatedata,
                          userdata[0],
                          function (updateddata) {
                            if (updateddata != null) {
                              callback(
                                globals.SUCCESS,
                                {
                                  keyword: "rest_keywords_user_login_success",
                                  content: {},
                                },
                                userdetails
                              );
                            } else {
                              callback(
                                globals.OPRETION_FAILD,
                                {
                                  keyword:
                                    "rest_keywords_user_data_update_fail",
                                  content: {},
                                },
                                false
                              );
                            }
                          }
                        );
                      }
                    }
                  );
                }
              });
            } else {
              callback(
                globals.OPRETION_FAILD,
                {
                  keyword: "rest_keyword_invalid_creadintials",
                  content: {},
                },
                {}
              );
            }
          } else {
            callback(
              globals.OPRETION_FAILD,
              {
                keyword: "rest_keyword_invalid_creadintials",
                content: {},
              },
              {}
            );
          }
        }
      );
    });
  },


  //=========================== Update User details ============================
  updateUser: function (updatedata, request, callback) {
    console.log(updatedata);
    console.log("$$$$$", request.user_id);
    connection.query(
      `UPDATE tbl_user SET ? WHERE is_deleted=0 and id='${request.user_id}' `,
      [updatedata],
      function (err, updateddata) {
        if (!err) {
          callback(true);
        } else {
          callback(false);
        }
      }
    );
  },


  //---------------------------FORGOT PASSWORD------------------------------

  reset_password: function (request, callback) {
    console.log("request", request);

    var enc_password = "";
    middleware.encryption(request.new_password, function (request) {
      enc_password = request;
    });

    connection.query(
      `select id as user_id,email,phone_number FROM tbl_user WHERE email='${request.email}' and is_active=1 and is_deleted=0`,
      function (error, result) {
        console.log(this.sql);
        console.log(result);
        if (!error) {
          updatedata = {
            password: enc_password,
          };
          auth.updateUser(updatedata, result[0], function (isUpdated) {
            if (isUpdated) {
              callback(
                globals.SUCCESS,
                { keyword: "rest_keyword_password_set", content: {} },
                true
              );
            } else {
              callback(
                globals.OPRETION_FAILD,
                {
                  keyword: "rest_keywords_user_data_update_fail",
                  content: {},
                },
                false
              );
            }
          });
        } else {
        callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_invalid_email_id", content: {} },
            null
          );
        }
      }
    );
  },

  //=========================== Forgot Password ===========================
 

  forgotPassword: function (request, callback) {
    //var otp = common.generatecode();
    var otp=1234;
    connection.query(
      `select id as user_id,email,phone_number FROM tbl_user WHERE email='${request.email}' and is_active=1 and is_deleted=0`,
      function (err, data) {
        if (!err && data.length > 0) {
          emailTemplate.forgot_password(otp, function (forgot_password) {
            common.sendEmail(
              request.email,
              "Forgot Password OTP",
              forgot_password,
              function (isSend) {
                if (isSend) {
                  updatedata = {
                    otp: otp,
                    is_forgot: 1,
                  };
                  auth.updateUser(updatedata, data[0], function (isUpdated) {
                    if (isUpdated) {
                      callback(
                        globals.SUCCESS,
                        { keyword: "rest_keywords_success", content: {} },
                        true
                      );
                    } else {
                      callback(
                        globals.OPRETION_FAILD,
                        {
                          keyword: "rest_keywords_user_data_update_fail",
                          content: {},
                        },
                        false
                      );
                    }
                  });
                } else {
                  callback(
                    globals.OPRETION_FAILD,
                    {
                      keyword: "rest_keywords_failed_to_send_email",
                      content: {},
                    },
                    false
                  );
                }
              }
            );
          });
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keywords_something_went_wrong", content: {} },
            null
          );
        }
      }
    );
  },

 //==================== Logout =====================================
  logout: function (request, callback) {
    console.log(request);
    connection.query(
      `UPDATE tbl_user SET is_online='0' WHERE is_deleted='0' and id=${request.user_id}`,
      function (error, result) {
        console.log(this.sql);
        console.log(result);
        if (!error) {
          connection.query(
            `DELETE FROM tbl_user_device WHERE user_id=${request.user_id}`,
            function (err, data) {
              if (!err) {
                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_userlogout_success", content: {} },
                  true
                );
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keywords_failed_message", content: {} },
            {}
          );
        }
      }
    );
  },

  //==================== Change Password ============================
  changepassword: function (request, callback) {
    // console.log("===========",request);
    auth.getUserDetails(request, function (code, message, userdetails) {
      //console.log("userdata", userdetails);
      var password = "";
      var newPassword = "";
      if (userdetails != null) {
        //middleware.encryption(request.password, function (enc_password)) { };
        var currentpassword = middleware.decryption(
          userdetails.userdetails.password,
          function (userprofileassword) {
            password = userprofileassword;
          }
        );

        //console.log(password);
        if (password != request.old_password) {
          callback(
            globals.OPRETION_FAILD,
            {
              keyword: "rest_keywords_user_old_password_incorrect",
              content: {},
            },
            null
          );
        } else if (password == request.new_password) {
          callback(
            globals.OPRETION_FAILD,
            {
              keyword: "rest_keywords_user_new_and_old_password_similar",
              content: {},
            },
            null
          );
        } else {
          var password = middleware.encryption(
            request.new_password,
            function (Newpassword) {
              newPassword = Newpassword;
            }
          );

          var updparams = {
            password: newPassword,
          };
          auth.updateUser(updparams, request, function (userprofile) {
            //console.log(userprofile);
            if (userprofile == null) {
              callback(
                globals.OPRETION_FAILD,
                {
                  keyword: "text_user_something_wrong",
                  content: {},
                },
                null
              );
            } else {
              callback(
                globals.SUCCESS,
                {
                  keyword: "rest_keywords_user_change_password_success",
                  content: {},
                },
                userprofile
              );
            }
          });
        }
      } else {
        callback(
          globals.OPRETION_FAILD,
          { keyword: "rest_keyword_no_data", content: {} },
          null
        );
      }
    });
  },

  //-------------------------verify otp--------------------------------------
  otpVerify: function (request, callback) {
    connection.query(
      `select id as user_id,country_code_id,phone_number,email,otp from tbl_user where email='${request.email}' and is_active=1 and is_deleted=0`,
      function (err, userdata) {
        if (!err && userdata.length > 0) {
          //console.log(userdata);
          if (request.otp == userdata[0].otp) {
            updatedata = {
              otp: "0",
              email_verified: "1",
            };
            auth.updateUser(updatedata, userdata[0], function (isUpdated) {
              if (isUpdated) {
                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_verify_code_success", content: {} },
                  true
                );
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  {
                    keyword: "rest_keywords_user_data_update_fail",
                    content: {},
                  },
                  false
                );
              }
            });
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "rest_keyword_otp_incorrect", content: {} },
              null
            );
          }
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keywords_something_went_wrong", content: {} },
            null
          );
        }
      }
    );
  },

  //====================== Update Profile ===============
  updateProfile: function (request, callback) {
    var data = {
      ...(request.profile_image != undefined && {
        profile_image: request.profile_image,
      }),
      ...(request.nmae != undefined && { name: request.name }),
      ...(request.country_code_id != undefined && {
        country_code_id: request.country_code_id,
      }),
      ...(request.phone_number != undefined && {
        phone_number: request.phone_number,
      }),
    };
    connection.query(
      `update tbl_user set ? where id=${request.user_id}`,
      [data],
      function (err, result) {
        if (!err && request.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result[0]
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keywords_something_went_wrong", content: {} },
            null
          );
        }
      }
    );
  },

  //=================== Delete User =====================
  deleteUser: function (request, callback) {
    conn.query(
      `UPDATE tbl_user SET is_online=0,is_deleted='1',is_active=0 WHERE id=${request.user_id}`,
      function (err, result) {
        if (!err) {
          var token_delete = "DELETE FROM `tbl_user_device` WHERE user_id=?";
          conn.query(token_delete, [request.user_id], function (err, result) {
            if (!err) {
              callback(
                globals.SUCCESS,
                { keyword: "rest_keywords_Delete_account", content: {} },
                null
              );
            } else {
              callback(
                globals.OPRETION_FAILD,
                { keyword: "rest_keywords_something_went_wrong", content: {} },
                null
              );
            }
          });
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keywords_something_went_wrong", content: {} },
            null
          );
        }
      }
    );
  },

  //=================== Get Country Code ===========================
  getCountryCode: function (request, callback) {
  console.log(request);
    connection.query(
      `SELECT * FROM tbl_country_code WHERE is_active=1 AND is_delete=0`,
      function (error, result) {
        if (!error && result.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keywords_something_went_wrong", content: {} },
            null
          );
        }
      }
    );
  },
};

module.exports = auth;

