const connection = require("../../../config/database");
var asyncLoop = require("node-async-loop");
var GLOBAL = require("../../../config/constant");
var common = require("../../../config/common");
const { required } = require("../../../language/en");
const { request } = require("express");
var middleware = require("../../../middleware/validator");
const globals = require("../../../config/constant");


var user = {
  //==================== Total Count ================================
  
  // reconnection count pending
  totalcount: function (request, callback) {
    connection.query(
      `SELECT COUNT(id) AS total_count,CONCAT(ROUND((COUNT(id) / 100 * 100), 0), '%') AS percentage from tbl_follow_up where is_deleted=0 AND user_id=${request.user_id} AND DATE(create_at) = CURDATE();`,
      function (error, followups) {
        //  console.log(sql);
        if (!error) {
          connection.query(
            `SELECT COUNT(c.id) AS total_count,CONCAT(ROUND((COUNT(c.id) / 100 * 100), 0), '%') AS percentage,(u.today_contact - COUNT(c.id)) AS total_contacts FROM tbl_contact c JOIN tbl_user u ON u.id = c.user_id WHERE c.is_deleted = 0 AND c.user_id = ${request.user_id} AND DATE(c.created_at) = CURDATE()`,
            function (error, contacts) {
              if (!error) {
                connection.query(
                  `SELECT COUNT(id) AS total_count,CONCAT(ROUND((COUNT(id) / 100 * 100), 0), '%') AS percentage from tbl_scheduled_meeting where  is_deleted=0 AND user_id=${request.user_id} AND DATE(create_at) = CURDATE()`,
                  function (error, mettings) {
                    if (!error) {
                  connection.query(
              `SELECT COUNT(c.id) AS total_count,CONCAT(ROUND((COUNT(c.id) / 100 * 100), 0), '%') AS percentage FROM tbl_contact c LEFT JOIN tbl_follow_up fu ON fu.contact_id = c.id LEFT JOIN tbl_scheduled_meeting m ON m.contact_id = c.id LEFT JOIN tbl_chat_logs cl ON cl.contact_id = c.id WHERE fu.contact_id IS NULL AND m.contact_id IS NULL AND cl.contact_id IS NULL AND c.is_deleted = 0 AND c.user_id =${request.user_id} AND c.created_at < CURRENT_DATE - INTERVAL '60' day`,
                        function (error, reconnect) {
                          if (!error) {
                          callback(globals.SUCCESS,{keyword: "rest_keywords_success_message",content: {},},
                        {followups: followups,contacts: contacts,meetings: mettings,reconnect: reconnect,});
                          }
                          else
                          {
                          callback(globals.OPRETION_FAILD,{keyword: "rest_keyword_no_data",content: {},},null);
                          }
                        }); 
                    } else {
                      callback(
                        globals.OPRETION_FAILD,
                        {
                          keyword: "rest_keyword_no_data",
                          content: {},
                        },
                        null
                      );
                    }
                  }
                );
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "text_user_something_wrong", content: {} },
                  error
                );
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //===================== Contact listing ===========================
 
  contacts: function (request, callback) {
    let query = `SELECT c.id as contact_id,c.type,c.firstname, c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}','${globals.CONTACT_PROFILE}',c.profile_image) AS profile_image, c.level, c.last_update, c.language_id, c.timezone_id,c.compnay_name, c.alternate_email, c.additional_phone_number, c.hashtags, c.contact_method, c.last_update, c.notes,DATE_FORMAT(c.created_at, '%m/%d/%y') as created_at, ct.name as contact_type FROM tbl_contact c JOIN tbl_contacts_type ct ON ct.id = c.type WHERE c.is_deleted = 0 AND DATE(c.created_at) = CURDATE() AND c.user_id = ${request.user_id}`;

    if (request.filter_id) {
      query += ` AND type = ${request.filter_id}`;
    }

    connection.query(query, function (error, result) {
      if (!error && result.length > 0) {
        callback(
          globals.SUCCESS,
          { keyword: "rest_keywords_success_message", content: {} },
          result
        );
      } else {
        callback(
          globals.OPRETION_FAILD,
          { keyword: "rest_keyword_no_data", content: {} },
          error
        );
      }
    });
  },

  //===================== Follow-ups listing ========================
  followups: function (request, callback) {
    let query = `SELECT fu.id as followup_id,fu.is_completed,fu.followup_completion_notes,fu.followup_completion_file,fu.is_repeat,fu.repeat_followup,fu.custom_date,cn.type,fu.create_at as followup_created,fu.date,fu.notes,cn.id as contact_id,cn.firstname,cn.lastname,cn.level,CONCAT('${globals.S3_BUCKET_ROOT}','${globals.CONTACT_PROFILE}',cn.profile_image) AS profile_image,cn.language_id,cn.timezone_id,cn.compnay_name,cn.alternate_email,cn.additional_phone_number,cn.hashtags,cn.contact_method,cn.notes,cnt.name AS contact_type from tbl_follow_up fu JOIN tbl_contact cn ON cn.id=fu.contact_id JOIN tbl_contacts_type cnt ON cnt.id=cn.type where cn.is_deleted=0 AND fu.is_deleted='0' AND DATE(fu.create_at) = CURDATE() AND fu.user_id=${request.user_id}`;

    if (request.filter_id) {
      query += ` AND cn.type = ${request.filter_id}`;
    }

    connection.query(query, function (error, result) {
     //console.log(this.sql);

      if (!error && result.length > 0) {
        callback(
          globals.SUCCESS,
          { keyword: "rest_keywords_success_message", content: {} },
          result
        );
      } else {
        callback(
          globals.OPRETION_FAILD,
          { keyword: "rest_keyword_no_data", content: {} },
          error
        );
      }
    });
  },

  //===================== Meeting listing ============================
  meetings: function (request, callback) {
 let query = `SELECT sm.id as meeting_id,sm.is_completed,cn.id as contact_id,cn.type,cn.firstname,cn.lastname,cn.level,cn.language_id,cn.timezone_id,cn.compnay_name,cn.alternate_email,cn.additional_phone_number,CONCAT('${globals.S3_BUCKET_ROOT}','${globals.CONTACT_PROFILE}',cn.profile_image) AS profile_image,cn.hashtags,cn.contact_method,cn.last_update,sm.notes,sm.date,sm.start_time,sm.end_time,sm.file,sm.create_at as meeting_create,cnt.name AS contact_type FROM tbl_scheduled_meeting sm JOIN tbl_contact cn ON cn.id=sm.contact_id JOIN tbl_contacts_type cnt ON cnt.id=cn.type WHERE cn.is_deleted=0 AND sm.is_deleted='0' AND DATE(sm.date)= CURDATE() AND sm.user_id=${request.user_id}`;
    if (request.filter_id) {
      query += ` AND cn.type = ${request.filter_id}`;
    }

    connection.query(query, function (error, result) {
      if (!error && result.length > 0) {
        callback(
          globals.SUCCESS,
          { keyword: "rest_keywords_success_message", content: {} },
          result
        );
      } else {
        callback(
          globals.OPRETION_FAILD,
          { keyword: "rest_keyword_no_data", content: {} },
          error
        );
      }
    });
  },


  //===================== All Contact type listing ==================
  contactType: function (request, callback) {
    connection.query(
      `SELECT id,user_id,name,color_code,CASE WHEN user_id = 0 THEN '0'ELSE '1' END AS type FROM tbl_contacts_type where user_id=0 or user_id=${request.user_id} and is_deleted=0`,
      function (error, result) {
        if (!error && result.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },
  
  //-------------------- Add all Notes -------------------------------
  addNotes: function (request, callback) {
    var data = {
      notes: request.notes,
      file: request.file,
    };
    if (request.label_id == 0) {
      connection.query(
        `UPDATE tbl_contact SET ? WHERE user_id = ${request.user_id} AND contact_id = ${request.contact_id}`,
        [data],
        function (error, result) {
          if (!error) {
            callback(
              globals.SUCCESS,
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "text_user_something_wrong", content: {} },
              error
            );
          }
        }
      );
    } else if (request.label_id == 1) {
      connection.query(
        `UPDATE tbl_follow_up SET ? WHERE user_id = ${request.user_id} AND contact_id = ${request.contact_id}`,
        [data],
        function (error, result) {
          if (!error) {
            callback(
              globals.SUCCESS,
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "text_user_something_wrong", content: {} },
              error
            );
          }
        }
      );
    } else if (request.label_id == 2) {
      connection.query(
        `UPDATE tbl_scheduled_meeting SET ? WHERE user_id = ${request.user_id} AND contact_id = ${request.contact_id}`,
        [data],
        function (error, result) {
          if (!error) {
            callback(
              globals.SUCCESS,
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "text_user_something_wrong", content: {} },
              error
            );
          }
        }
      );
    } else if (request.label_id == 3) {
      connection.query(
        `UPDATE tbl_reconnects SET ? WHERE user_id = ${request.user_id} AND contact_id = ${request.contact_id}`,
        [data],
        function (error, result) {
          if (!error) {
            callback(
              globals.SUCCESS,
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "text_user_something_wrong", content: {} },
              error
            );
          }
        }
      );
    }
  },

  //==================== Add Followup Notes ===========================
  addFollowupNotes: function (request, callback) {
    //console.log(request.user_id);
   var data = {
      notes: request.notes,
      file: request.file ? request.file : "",
    };
    //console.log(data);
    connection.query(
      `UPDATE tbl_follow_up SET ? WHERE user_id = ${request.user_id} AND id = ${request.followup_id}`,
      [data],
      function (error, result) {
       //console.log(this.sql);
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //===================== Add Followup ================================
  addFollowup: function (request, callback) {
    data = {
      contact_id: request.contact_id,
      user_id: request.user_id,
      notes: request.notes ? request.notes : "",
      file: request.file ? request.file : "",
      contact_id: request.contact_id,
      date: request.date,
      time: request.time ? request.time : "",
      timezone_id: request.timezone_id ? request.timezone_id : "",
      is_repeat: request.is_repeat,
      repeat_followup: request.repeat ? request.repeat : null,
      custom_date: request.custom_date ? request.custom_date : null,
    };

    //console.log(data);

    connection.query(
      `insert into tbl_follow_up SET ?`,
      [data],
      function (error, result) {
       // console.log(this.sql);
        //console.log(result);
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            null
          );
        }
      }
    );
  },

  //===================== Delete Followup =============================
  deleteFollowup: function (request, callback) {
    // console.log(request);
    connection.query(
      "UPDATE tbl_follow_up SET is_deleted ='1' WHERE user_id = ? AND id = ?",
      [request.user_id, request.followup_id],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //==================== Add Meeting Notes ===========================
  addMeetingNotes: function (request, callback) {
    const data = {
      notes: request.notes,
      file: "",
    };

    connection.query(
      "UPDATE tbl_scheduled_meeting SET ? WHERE user_id = ? AND id = ?",
      [data, request.user_id, request.meeting_id],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //==================== Add Meeting ================================
  addMeeting: function (request, callback) {
    //var today = new Date();
    var data = {
      contact_id: request.contact_id,
      user_id: request.user_id,
      notes: request.notes,
      link: request.link,
      file: request.file ? request.file : "",
      date: request.date,
      start_time: request.start_time,
      end_time: request.end_time,
    };

    connection.query(
      "insert into tbl_scheduled_meeting SET ? ",
      [data],
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //===================== Delete Meeting =============================
  deleteMeeting: function (request, callback) {
   // console.log(request);
    connection.query(
      "UPDATE tbl_scheduled_meeting SET is_deleted ='1' WHERE user_id = ? AND id = ?",
      [request.user_id, request.meeting_id],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=================== Reconnect listing ============================
  reconnects: function (request, callback) {
    let query = `SELECT c.id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}','${globals.CONTACT_PROFILE}',c.profile_image) AS profile_image,c.level,ct.name,c.notes FROM tbl_contact c LEFT JOIN tbl_follow_up fu ON fu.contact_id = c.id  LEFT JOIN tbl_scheduled_meeting m ON m.contact_id = c.id LEFT JOIN tbl_chat_logs cl ON cl.contact_id = c.id join tbl_contacts_type ct on ct.id=c.type WHERE fu.contact_id IS NULL AND m.contact_id IS NULL AND cl.contact_id IS NULL AND c.is_deleted = 0 AND c.user_id =${request.user_id} AND c.created_at < CURRENT_DATE - INTERVAL '60' day`;

    connection.query(query, function (error, result) {
      if (!error) {
        callback(
          globals.SUCCESS,
          { keyword: "rest_keywords_success_message", content: {} },
          result
        );
      } else {
        callback(
          globals.OPRETION_FAILD,
          { keyword: "text_user_something_wrong", content: {} },
          error
        );
      }
    });
  },

  //==================== Add Reconnect Notes =========================
  addReconnectsNotes: function (request, callback) {
    const data = {
      notes: request.notes,
      file: "",
    };

    connection.query(
      "UPDATE tbl_reconnects SET ? WHERE user_id = ? AND contact_id = ?",
      [data, request.user_id, request.contact_id],
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //===================== Delete Reconnect ============================
  deleteReconnects: function (request, callback) {
    // console.log(request);
    connection.query(
      "UPDATE tbl_reconnects SET is_deleted ='1' WHERE user_id = ? AND contact_id = ?",
      [request.user_id, request.contact_id],
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=================== Add new contact type ===========================
  addNewType: function (request, callback) {
    var data = {
      user_id: request.user_id,
      name: request.name,
      color_code: request.color,
    };

    connection.query(
      `INSERT INTO tbl_contacts_type SET ?`,
      [data],
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //==================== Rename Contact type ===========================
  renameType: function (request, callback) {
    //console.log(request);
    connection.query(
      "UPDATE tbl_contacts_type SET name = ? WHERE is_deleted = '0' AND id = ? AND user_id=?",
      [request.name, request.id,request.user_id],
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=================== Delete Contact type ============================
  deleteType: function (request, callback) {
    connection.query(
      `UPDATE tbl_contacts_type SET is_deleted ='1' WHERE id =${request.id} AND user_id=${request.user_id}`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //==================== Filter Level Wise ============================
  filteLevel: function (request, callback) {
    //console.log(request);
    connection.query(
      `SELECT c.id,c.firstname,c.lastname,c.level,ct.name as type,DATE_FORMAT(c.created_at, '%d %b, %Y') as created_at,CONCAT('${globals.S3_BUCKET_ROOT}','${globals.CONTACT_PROFILE}',c.profile_image) AS profile_image FROM tbl_contact c JOIN tbl_contacts_type ct ON ct.id=c.type WHERE c.is_deleted=0 and c.level='${request.level}' and c.user_id=${request.user_id}`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //============= Contacts Filtering Right side =======================
  contactsFiltering: function (request, callback) {
    connection.query(
      `SELECT id,firstname,lastname,CONCAT('${globals.S3_BUCKET_ROOT}','${globals.CONTACT_PROFILE}',profile_image) AS profile_image,level,DATE_FORMAT(created_at, '%m/%d/%y') as created_at,"recent" as filter FROM tbl_contact WHERE is_deleted=0 and user_id=${request.user_id} ORDER BY created_at DESC`,
      function (error, recentData) {
        if (!error ) {
          connection.query(
            `SELECT c.id,c.user_id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}',c.profile_image) AS profile_image,c.level, DATE_FORMAT(c.created_at, '%m/%d/%y') as created_at, "lowInterest" as filter FROM tbl_contact c WHERE c.user_id =${request.user_id} AND c.is_deleted = 0 AND (SELECT COUNT(*) FROM (SELECT contact_id, created_at FROM tbl_follow_up UNION ALL SELECT contact_id, created_at FROM tbl_scheduled_meeting UNION ALL SELECT contact_id, created_at FROM tbl_chat_logs) interactions WHERE interactions.contact_id = c.id AND interactions.created_at BETWEEN c.created_at AND c.created_at + INTERVAL '60' day) BETWEEN 1 AND 5 ORDER BY c.created_at DESC`,
            function (error, lowData) {
              if (!error) {
                connection.query(
                  `SELECT c.id,c.user_id,c.firstname,c.lastname,c.level,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}',c.profile_image) AS profile_image,DATE_FORMAT(c.created_at, '%m/%d/%y') as created_at,"highInterest" as filter FROM tbl_contact c WHERE c.user_id = ${request.user_id} AND c.is_deleted = 0 AND (SELECT COUNT(*) FROM (SELECT contact_id, created_at FROM tbl_follow_up UNION ALL SELECT contact_id, created_at FROM tbl_scheduled_meeting UNION ALL SELECT contact_id, created_at FROM tbl_chat_logs) interactions WHERE interactions.contact_id = c.id AND interactions.created_at BETWEEN c.created_at AND c.created_at + INTERVAL '60' day) >= 6  ORDER BY c.created_at DESC`,
                  function (error, hightData) {
                    if (!error) {
                      connection.query(
                          `SELECT c.id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}','${globals.CONTACT_PROFILE}',c.profile_image) AS profile_image,DATE_FORMAT(c.created_at, '%m/%d/%y') as created_at,c.level,"reconnect" as filter FROM tbl_contact c LEFT JOIN tbl_follow_up fu ON fu.contact_id = c.id  LEFT JOIN tbl_scheduled_meeting m ON m.contact_id = c.id LEFT JOIN tbl_chat_logs cl ON cl.contact_id = c.id WHERE fu.contact_id IS NULL AND m.contact_id IS NULL AND cl.contact_id IS NULL AND c.is_deleted = 0 AND c.user_id =${request.user_id} AND c.created_at < CURRENT_DATE - INTERVAL '60' day`,
                          function (error, reconnect) {
                            if (!error) {
                              const data = [
                                ...recentData,
                                ...lowData,
                                ...hightData,
                                ...reconnect,
                              ];
                              callback(
                                globals.SUCCESS,
                                {
                                  keyword: "rest_keywords_success_message",
                                  content: {},
                                },
                                data
                              );
                            } else {
                              callback(
                                globals.OPRETION_FAILD,
                                {
                                  keyword: "text_user_something_wrong",
                                  content: {},
                                },
                                error
                              );
                            }
                          }
                        );
                    } else {
                      callback(
                        globals.OPRETION_FAILD,
                        {
                          keyword: "text_user_something_wrong",
                          content: {},
                        },
                        error
                      );
                    }
                  }
                );
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "text_user_something_wrong", content: {} },
                  error
                );
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //================= All Filter Contact ==================================
  getAllContacts: function (request, callback) {
    var query = `SELECT c.id,c.user_id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}','${globals.CONTACT_PROFILE}',c.profile_image) AS profile_image,c.level,c.created_at,ct.name as type FROM tbl_contact c JOIN tbl_contacts_type ct ON ct.id=c.type WHERE c.is_active=1 AND c.is_deleted=0 AND c.user_id =${request.user_id} ORDER BY c.created_at DESC`;

    if (request.filter_id) {
      query += `AND c.type = ${request.filter_id}`;
    }

    connection.query(query, function (error, result) {
      if (!error) {
        callback(
          globals.SUCCESS,
          { keyword: "rest_keywords_success_message", content: {} },
          result
        );
      } else {
        callback(
          globals.OPRETION_FAILD,
          { keyword: "text_user_something_wrong", components: {} },
          error
        );
      }
    });
  },

  //================ Add Contact ======================================
  addContact: function (request, callback) {
    var data = {
      user_id: request.user_id,
      firstname: request.firstname,
      lastname: request.lastname,
      country_code: request.country_code,
      email: request.email,
      phone_number: request.phone_number,
      type: request.type,
    };

    connection.query(
      `INSERT INTO tbl_contact SET ?`,
      [data],
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=============== Delete Contact ===================================
  deleteContact: function (request, callback) {
    connection.query(
      `UPDATE tbl_contact SET is_deleted ='1' WHERE id =${request.contact_id} AND user_id=${request.user_id}`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=============== Get Contact Details ===============================
 viewContactDetails: function (request, callback) {
    // console.log("=========", request);
    connection.query(
      `SELECT cn.id,cn.user_id,cn.language_id,cn.timezone_id,cn.firstname,cn.lastname,cn.compnay_name,cn.email,cn.alternate_email,cn.phone_number,cn.additional_phone_number,cn.country_code,CONCAT('${globals.S3_BUCKET_ROOT}','${globals.CONTACT_PROFILE}',cn.profile_image) AS profile_image,cn.level,cn.hashtags,cn.contact_method,cn.last_update,cn.status,cn.notes,cn.address,cn.is_active,cn.created_at,cn.updated_at,cnt.id as type_id,cnt.name as type,cnt.color_code FROM tbl_contact cn JOIN tbl_contacts_type cnt ON cnt.id=cn.type WHERE cn.is_deleted=0 and cn.id=${request.contact_id} `,
      function (error, result) {
        //console.log(this.sql);
        if (!error && result.length > 0) {
          user.contactSocialMedia(request, function (code, message, data) {
            //console.log(message);
            if (code == "1") {
              callback(
                globals.SUCCESS,
                { keyword: "rest_keywords_success_message", content: {} },
                { details: result, socialMedia: data }
              );
            } else {
              callback(
                globals.SUCCESS,
                { keyword: "rest_keywords_success_message", content: {} },
                { details: result, socialMedia: code }
              );
            }
          });
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            error
          );
        }
      }
    );
  },

 //=============== Contact social media list ========================
  contactSocialMedia: function (request, callback) {
    connection.query(
      `SELECT csm.contact_id,csm.social_media_id,csm.link,sm.name,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.SOCIAL_MEDIA}', sm.image) AS image FROM tbl_contact_social_media csm JOIN tbl_social_media sm ON sm.id=csm.social_media_id WHERE sm.is_deleted=0 and csm.is_deleted=0 and csm.contact_id=${request.contact_id}`,
      function (error, result) {
      //console.log(this.sql)
        if (!error && result.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            error
          );
        }
      }
    );
  },
  
  //=============== Add social media ================================
  addContactSocialmedia: function (request, callback) {
    var data = {
      social_media_id: request.social_media_id,
      contact_id: request.contact_id,
      link: request.social_media_link,
    };
    connection.query(
      `INSERT INTO tbl_contact_social_media SET ?`,
      [data],
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            null
          );
        }
      }
    );
  },
  
  //============== Update Contact Details ============================
   updateContactDetails: function (request, callback) {
    //console.log("request", request);
    var data = {
      firstname: request.firstname,
      lastname: request.lastname,
      email: request.email,
      country_code: request.country_code_id,
      phone_number: request.phone_number,
      type: request.type,
      compnay_name: request.compnay_name ? request.compnay_name : "",
      alternate_email: request.alternate_email ? request.alternate_email : "",
      additional_phone_number: request.additional_phone_number
        ? request.additional_phone_number
        : "",
      profile_image: request.profile_image ? request.profile_image : "",
      hashtags: request.hashtags ? request.hashtags : "",
      address: request.address ? request.address : "",
      contact_method: request.contact_method ? request.contact_method : "",
      timezone_id: request.timezone_id ? request.timezone_id : "",
      language_id: request.language_id ? request.language_id : "",
      level: request.level ? request.level : "",
      last_update: request.last_update ? request.last_update : "",
    };

    connection.query(
      `UPDATE tbl_contact SET ? WHERE user_id=${request.user_id} AND id=${request.contact_id}`,
      [data],
      function (error, result) {
         
        if (!error) {

          if (request.socialmedia != null) {

            asyncLoop(
              request.socialmedia,
              function (item, next) {
                connection.query(
                  `SELECT * FROM tbl_contact_social_media WHERE social_media_id=${item.social_media_id} AND contact_id=${request.contact_id}`,
                  function (error, existingData) {
                    if (!error) {
                      if (existingData.length > 0) {
                        // If data exists, update the record
                        connection.query(
                          `UPDATE tbl_contact_social_media SET link='${item.social_media_link}' WHERE social_media_id=${item.social_media_id} AND contact_id=${request.contact_id}`,
                          function (error, updateResult) {
                            if (!error) {
                              console.log("Updated successfully");
                            } else {
                              console.log("Failed to update");
                            }
                            next();
                          }
                        );
                      } else {
                        // If data doesn't exist, insert a new record
                        connection.query(
                          `INSERT INTO tbl_contact_social_media SET ?`,
                          {
                            social_media_id: item.social_media_id,
                            contact_id: request.contact_id,
                            link: item.social_media_link,
                          },
                          function (error, insertResult) {
                            if (!error) {
                              console.log("Inserted successfully");
                            } else {
                              console.log("Failed to insert");
                            }
                            next();
                          }
                        );
                      }
                    } else {
                      //console.log("Error while querying existing data");
                      next(error);
                    }
                  }
                );
              },
              function (error) {
                if (error) {
                  callback(
                    globals.OPRETION_FAILD,
                    {
                      keyword: "rest_keyword_no_data",
                      content: {},
                    },
                    error
                  );
                } else {
                  user.viewContactDetails(
                    request,
                    function (code, message, data) {
                      if (code == "1") {
                        callback(
                          globals.SUCCESS,
                          {
                            keyword: "rest_keywords_success_message",
                            content: {},
                          },
                          data
                        );
                      } else {
                        callback(
                          globals.OPRETION_FAILD,
                          {
                            keyword: "rest_keyword_no_data",
                            content: {},
                          },
                          error
                        );
                      }
                    }
                  );
                }
              }
            );
          } else {
            user.viewContactDetails(request, function (code, message, data) {
              if (code == "1") {
                callback(
                  globals.SUCCESS,
                  {
                    keyword: "rest_keywords_success_message",
                    content: {},
                  },
                  data
                );
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  {
                    keyword: "rest_keyword_no_data",
                    content: {},
                  },
                  error
                );
              }
            });
          }
   
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //============= Notification listing ==============================
  notificationListing: function (request, callback) {
    //console.log(request.user_id);
    connection.query(
      `SELECT * FROM tbl_notification WHERE is_deleted=0 and receiver_id=?`,
      [request.user_id],
      function (error, result) {
       // console.log(result);
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
             globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //============= languageListing ===================================
  languageListing: function (request, callback) {
    connection.query(
      `SELECT id,name FROM tbl_language WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //============ socialMediaListing =================================
  socialMediaListing: function (request, callback) {
    connection.query(
      `SELECT * FROM tbl_social_media WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=========== timeZoneListing =====================================
  timeZoneListing: function (request, callback) {
    connection.query(
      `SELECT * FROM tbl_timezone WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=========== Team Goal ==========================================
  teamGoal: function (request, callback) {
    if (request.to_date && request.from_date) {
      connection.query(
        `SELECT te.id as team_id,COUNT(sm.id) AS meeting,CONCAT(ROUND((COUNT(sm.id) / 100 * 100), 0), '%') AS percentage FROM tbl_team te JOIN tbl_team_members tm ON tm.team_id=te.id JOIN tbl_scheduled_meeting sm ON sm.user_id=tm.member_id WHERE te.is_deleted=0 AND DATE(sm.create_at) BETWEEN '${request.to_date}' AND '${request.from_date}' AND te.id=${request.team_id}`,
        function (error, meetings) {
          if (!error) {
            connection.query(
              `SELECT te.id as team_id,COUNT(fu.id) AS followup,CONCAT(ROUND((COUNT(fu.id) / 100 * 100), 0), '%') AS percentage FROM tbl_team te JOIN tbl_team_members tm ON tm.team_id=te.id JOIN tbl_follow_up fu ON fu.user_id=tm.member_id WHERE te.is_deleted=0 AND DATE(fu.create_at) BETWEEN '${request.to_date}' AND '${request.from_date}' AND te.id=${request.team_id}`,
              function (error, followups) {
                if (!error) {
                  connection.query(
                    `SELECT te.id as team_id,COUNT(cn.id) AS contact,CONCAT(ROUND((COUNT(cn.id) / 100 * 100), 0), '%') AS percentage FROM tbl_team te JOIN tbl_team_members tm ON tm.team_id=te.id JOIN tbl_contact cn ON cn.user_id=tm.member_id WHERE te.is_deleted=0 AND DATE(cn.created_at) BETWEEN '${request.to_date}' AND '${request.from_date}' AND te.id=${request.team_id}`,
                    function (error, contacts) {
                      if (!error) {
                        callback(
                          globals.SUCCESS,
                          {
                            keyword: "rest_keywords_success_message",
                            content: {},
                          },
                          {
                            meeting: meetings,
                            followup: followups,
                            contact: contacts,
                          }
                        );
                      } else {
                        callback(
                          globals.OPRETION_FAILD,
                          {
                            keyword: "rest_keyword_no_data",
                            content: {},
                          },
                          error
                        );
                      }
                    }
                  );
                } else {
                  callback(
                    globals.OPRETION_FAILD,
                    {
                      keyword: "rest_keyword_no_data",
                      content: {},
                    },
                    error
                  );
                }
              }
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              {
                keyword: "rest_keyword_no_data",
                content: {},
              },
              error
            );
          }
        }
      );
    } else {
      connection.query(
        `SELECT te.id as team_id,COUNT(sm.id) AS meeting,CONCAT(ROUND((COUNT(sm.id) / 100 * 100), 0), '%') AS percentage FROM tbl_team te JOIN tbl_team_members tm ON tm.team_id=te.id JOIN tbl_scheduled_meeting sm ON sm.user_id=tm.member_id WHERE te.is_deleted=0 AND DATE(sm.create_at) = CURDATE() AND te.id=${request.team_id}`,
        function (error, meetings) {
          if (!error) {
            connection.query(
              `SELECT te.id as team_id,COUNT(fu.id) AS followup,CONCAT(ROUND((COUNT(fu.id) / 100 * 100), 0), '%') AS percentage FROM tbl_team te JOIN tbl_team_members tm ON tm.team_id=te.id JOIN tbl_follow_up fu ON fu.user_id=tm.member_id WHERE te.is_deleted=0 AND DATE(fu.create_at) = CURDATE() AND te.id=${request.team_id}`,
              function (error, followups) {
                if (!error) {
                  connection.query(
                    `SELECT te.id as team_id,COUNT(cn.id) AS contact,CONCAT(ROUND((COUNT(cn.id) / 100 * 100), 0), '%') AS percentage FROM tbl_team te JOIN tbl_team_members tm ON tm.team_id=te.id JOIN tbl_contact cn ON cn.user_id=tm.member_id WHERE te.is_deleted=0 AND DATE(cn.created_at) = CURDATE() AND te.id=${request.team_id}`,
                    function (error, contacts) {
                      if (!error) {
                        callback(
                          globals.SUCCESS,
                          {
                            keyword: "rest_keywords_success_message",
                            content: {},
                          },
                          {
                            meeting: meetings,
                            followup: followups,
                            contact: contacts,
                          }
                        );
                      } else {
                        callback(
                          globals.OPRETION_FAILD,
                          {
                            keyword: "rest_keyword_no_data",
                            content: {},
                          },
                          error
                        );
                      }
                    }
                  );
                } else {
                  callback(
                    globals.OPRETION_FAILD,
                    {
                      keyword: "rest_keyword_no_data",
                      content: {},
                    },
                    error
                  );
                }
              }
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "rest_keyword_no_data", content: {} },
              error
            );
          }
        }
      );
    }
  },
  
  //====================== All teams listing ==============================
 allTeamListing: function (request, callback) {
    connection.query(
      `SELECT t.id as team_id,t.name,CONCAT('https//chatalott.com/', t.team_link) AS team_link,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.TEAM_PROFILE}', t.profile_image) AS profile_image FROM tbl_team t WHERE t.admin_id= ${request.user_id} AND is_deleted=0`,
      function (error, data) {
        if (!error && data.length > 0) {
          connection.query(
            `SELECT tm.id,tm.team_id,tm.member_id,t.name,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.TEAM_PROFILE}', t.profile_image) AS profile_image FROM tbl_team_members tm JOIN tbl_team t ON t.id=tm.team_id WHERE member_id=${request.user_id} AND tm.is_deleted=0 AND t.is_deleted=0`,
            function (error, result) {
              if (!error) {
                data.Member = result;
                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_success", content: {} },
                  data
                );
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "text_user_something_wrong", content: {} },
                  error
                );
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },
  
  //=========== Teammate Task ======================================
  teammateTask: function (request, callback) {
    connection.query(
      `SELECT COUNT(id) AS total_count,CONCAT(ROUND((COUNT(id) / 100 * 100), 0), '%') AS percentage FROM tbl_follow_up WHERE is_deleted = 0 AND user_id = ${request.teammate_id} AND DATE(create_at) = '${request.date}'`,
      function (error, followups) {
        //  console.log(sql);
        if (!error) {
          connection.query(
            `SELECT COUNT(id) AS total_count,CONCAT(ROUND((COUNT(id) / 100 * 100), 0), '%') AS percentage FROM tbl_contact WHERE is_deleted = 0 AND user_id = ${request.teammate_id} AND DATE(created_at) = '${request.date}'`,
            function (error, contacts) {
              if (!error) {
                connection.query(
                  `SELECT COUNT(id) AS total_count,CONCAT(ROUND((COUNT(id) / 100 * 100), 0), '%') AS percentage from tbl_scheduled_meeting where  is_deleted=0 AND user_id=${request.teammate_id} AND DATE(create_at) = '${request.date}'`,
                  function (error, mettings) {
                    if (!error) {
                      callback(
                        globals.SUCCESS,
                        {
                          keyword: "rest_keywords_success_message",
                          content: {},
                        },
                        {
                          followups: followups,
                          contacts: contacts,
                          meetings: mettings,
                        }
                      );
                    } else {
                      callback(
                        globals.OPRETION_FAILD,
                        {
                          keyword: "rest_keyword_no_data",
                          content: {},
                        },
                        {
                          followups: followups,
                          contacts: contacts,
                          meetings: mettings,
                        }
                      );
                    }
                  }
                );
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "text_user_something_wrong", content: {} },
                  error
                );
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },error);
        }
      }
    );
  },
  
  
   //======== Teammate Date Task =====================================
  teammateDateTask: function (request, callback) {
    connection.query(
      `SELECT COUNT(id) AS total_count,CONCAT(ROUND((COUNT(id) / 100 * 100), 0), '%') AS percentage FROM tbl_follow_up WHERE is_deleted = 0 AND user_id = ${request.teammate_id} AND DATE(create_at) = '${request.date}'`,
      function (error, followups) {
        //console.log(this.sql);
        if (!error) {
          connection.query(
            `SELECT COUNT(id) AS total_count,CONCAT(ROUND((COUNT(id) / 100 * 100), 0), '%') AS percentage FROM tbl_contact WHERE is_deleted = 0 AND user_id = ${request.teammate_id} AND DATE(created_at) = '${request.date}'`,
            function (error, contacts) {
              if (!error) {
                connection.query(
                  `SELECT COUNT(id) AS total_count,CONCAT(ROUND((COUNT(id) / 100 * 100), 0), '%') AS percentage from tbl_scheduled_meeting where  is_deleted=0 AND user_id=${request.teammate_id} AND DATE(create_at) = '${request.date}'`,
                  function (error, mettings) {
                    if (!error) {
                      callback(
                        globals.SUCCESS,
                        {
                          keyword: "rest_keywords_success_message",
                          content: {},
                        },
                        {
                          followups: followups,
                          contacts: contacts,
                          meetings: mettings,
                        }
                      );
                    } else {
                      callback(
                        globals.OPRETION_FAILD,
                        {
                          keyword: "rest_keyword_no_data",
                          content: {},
                        },
                        {
                          followups: followups,
                          contacts: contacts,
                          meetings: mettings,
                        }
                      );
                    }
                  }
                );
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "text_user_something_wrong", content: {} },
                  error
                );
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },
  
 //=========== Delete Team member ================================
  deleteTeamMember: function (request, callback) {
    connection.query(
      `UPDATE tbl_team_members SET is_deleted='1' WHERE team_id=${request.team_id} AND member_id=${request.teammate_id}`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=========== Team Listing ======================================
   teamListing: function (request, callback) {
    connection.query(
      `SELECT t.id, t.name,CONCAT('https//chatalott.com/', t.team_link) AS team_link,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.TEAM_PROFILE}', t.profile_image) AS profile_image, u.name AS admin, COUNT(tm.id) AS members 
        FROM tbl_team t 
        JOIN tbl_user u ON u.id = t.admin_id 
        JOIN tbl_team_members tm ON tm.team_id = t.id 
        WHERE t.is_deleted = 0 AND t.admin_id!=${request.user_id}
        GROUP BY t.id`,
      function (error, teamsResult) {
        if (!error && teamsResult.length > 0) {
          asyncLoop(
            teamsResult,
            function (team, nextTeam) {
              var search = request.search ? `AND u.name LIKE ?` : "";
              var searchParam = request.search
                ? "%" + request.search + "%"
                : "";

              var membersQuery = `SELECT tm.id, tm.team_id, tm.member_id, u.name, tm.created_at,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.USER_PROFILE}', u.profile_image) AS profile_image, u.notes FROM tbl_team_members tm JOIN tbl_user u ON u.id = tm.member_id WHERE tm.team_id = ? AND u.is_deleted = 0 ${search}`;

              connection.query(
                membersQuery,
                [team.id, searchParam],
                function (error, membersResult) {
                  if (!error) {
                    team.Members = membersResult;
                    nextTeam();
                  } else {
                    nextTeam(error);
                  }
                }
              );
            },
            function (loopError) {
              if (!loopError) {
                // Now, add the isMember field to each team object
                asyncLoop(
                  teamsResult,
                  function (item, next) {
                    var members = `SELECT t.id, t.admin_id, t.name 
                                        FROM tbl_team t 
                                        JOIN tbl_team_members tm ON tm.team_id = t.id 
                                        WHERE tm.member_id = ? AND t.id = ? AND t.is_deleted = 0 AND tm.is_deleted = 0`;

                    connection.query(
                      members,
                      [request.user_id, item.id],
                      function (error, data) {
                        if (!error && data.length > 0) {
                          item.isMember = true;
                        } else {
                          item.isMember = false;
                        }
                        next();
                      }
                    );
                  },
                  function (error) {
                    if (!error) {
                      callback(
                        globals.SUCCESS,
                        { keyword: "rest_keywords_success", content: {} },
                        teamsResult
                      );
                    } else {
                      callback(
                        globals.OPRETION_FAILD,
                        { keyword: "text_user_something_wrong", content: {} },
                        error
                      );
                    }
                  }
                );
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "text_user_something_wrong", content: {} },
                  loopError
                );
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },


  //=========== Create New Team ===================================
   creatTeam: function (request, callback) {

    var data = {
      name: request.team_name,
      profile_image: request.team_profile,
      admin_id: request.user_id,
    };

    connection.query(
      `INSERT INTO tbl_team SET ?`,
      [data],
      function (error, result) {
        if (!error) {
          if (request.member_id != null) {
          asyncLoop(
          request.member_id,
          function (item, next) {
            var team = {
              member_id: item,
              team_id: result.insertId,
            };
            connection.query(
              `INSERT INTO tbl_team_members SET ?`,
              [team],
              function (error, result) {
                next();
              }
            );
          },
          function (error) {
            if (error) {
              callback(
                globals.OPRETION_FAILD,
                {
                  keyword: "rest_keyword_no_data",
                  content: {},
                },
                error
              );
            } else {
              callback(
                globals.SUCCESS,
                {
                  keyword: "rest_keywords_success_message",
                  content: {},
                },
                result
              );
            }
          }
        );
        } else {
           
            callback(
              globals.SUCCESS,
              {
                keyword: "rest_keywords_success_message",
                content: {},
              },
              result
            );
          }
        } else {
          callback(
            globals.SUCCESS,
            {
              keyword: "rest_keywords_success_message",
              content: {},
            },
            result
          );
        }
      }
    );
  },
  
  //========== Genarate team Link ================================
  generateTeamLink: function (request, callback) {
    //console.log(request);
    var link = "";
    connection.query(
      `select id,name from tbl_team where id=${request.team_id}`,
      function (error, result) {
        if (!error && result.length > 0) {
          middleware.encryption(result[0].id, function (team_link) {
            link = team_link;
          });
          connection.query(
            `UPDATE tbl_team SET team_link='${link}' where id=${result[0].id}`,
            function (error, result) {
              //console.log(this.sql);
              if (!error) {
                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_success_message", content: {} },
                  result
                );
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "text_user_something_wrong", content: {} },
                  error
                );
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },


  //========== Join team ==========================================
 // joinTeam: function (request, callback) {
 //   var data = {
   //   team_id: request.team_id,
   //   member_id: request.user_id,
  //  };

  //  connection.query(
  //    `INSERT INTO tbl_team_members SET ?`,
  //    [data],
  //    function (error, result) {
  //      if (!error) {
 //         callback(
 //           "1",
//{ keyword: "rest_keywords_success_message", content: {} },
 //           result
 //         );
 //       } else {
 //         callback(
 //           "0",
 //           { keyword: "text_user_something_wrong", content: {} },
 //           error
 //        );
 //       }
//      }
 //   );
 // },
 
 
 joinTeam: function (request, callback) {
    var data = {
      team_id: request.team_id,
      member_id: request.user_id,
    };

    connection.query(
      `INSERT INTO tbl_team_members SET ?`,
      [data],
      function (error, result) {
        if (!error) {
          connection.query(
            `select id,name,email from tbl_user where id=${request.user_id} and is_deleted=0`,
            function (error, userinfo) {
              //console.log("user", userinfo);
              if (!error && userinfo.length > 0) {
                user.teamNotification(request, function (code, message, data) {
                  if (code == 1) {
                    callback(
                      globals.SUCCESS,
                      {
                        keyword: "rest_keywords_success_message",
                        content: {},
                      },
                      result
                    );
                  } else {
                    callback(
                      globals.OPRETION_FAILD,
                      { keyword: "text_user_something_wrong", content: {} },
                      error
                    );
                  }
                });
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "text_user_something_wrong", content: {} },
                  error
                );
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },
 
 //====================== team Notification ================================
 
  teamNotification: function (request, callback) {
    connection.query(
      `select id FROM tbl_team_members WHERE team_id=${request.team_id} and is_deleted=0`,
      function (error, result) {
        //console.log("members", result);
        const receiver_id = result.map((result) => result.id);
        // console.log(receiver_id);
        if (!error && result.length > 0) {
          var info = {
            sender_id: 0,
            receiver_id: receiver_id,
            title: "Join Team",
            message: "new member",
          };
          user.pushNotification(info, function (code, message, data) {
          if (code == "1") {
              callback(
                globals.SUCCESS,
                { keyword: "rest_keywords_success_message", content: {} },
                result
              );
            } else {
              callback(
                globals.OPRETION_FAILD,
                { keyword: "text_user_something_wrong", content: {} },
                error
              );
            }
          });
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

 //=========== push notification =================================
  pushNotification: function (request, callback) {
    //console.log("info", request);
   // console.log(request.receiver_id); //[ 1, 2, 3 ]
    asyncLoop(
      request.receiver_id,
      function (receiverId, next) {
        var data = {
          sender_id: request.sender_id,
          receiver_id: receiverId,
          title: request.title,
          message: request.message,
        };

        connection.query(
          `INSERT INTO tbl_notification SET ?`,
          [data],
          function (error, result) {
            //console.log(this.sql);
            if (!error) {
              callback(
                globals.SUCCESS,
                { keyword: "rest_keyword_sent_notification", content: {} },
                result
              );
              next();
            } else {
              next(error);
            }
          }
        );
      },
      function (error) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keyword_sent_notification", content: {} },
            true
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },
  
  
  //=========== Leave Team ========================================
  leaveTeam: function (request, callback) {
    connection.query(
      `DELETE FROM tbl_team_members WHERE member_id = ${request.user_id} AND team_id=${request.team_id}`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

 
  //=========== All Blog Listing ==================================
  allBloglisting: function (request, callback) {
    connection.query(
      `SELECT id,image,title,description FROM tbl_blog WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //================ View Blog ====================================
  viewBlog: function (request, callback) {
    connection.query(
      `SELECT id,image,title,description FROM tbl_blog WHERE is_deleted=0 and id=${request.blog_id}`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=============== All Chatavisity ===============================
  allChatavirsity: function (request, callback) {
    connection.query(
      `SELECT id,image,title,description,price FROM tbl_chatavirsity WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //================ View Chatavisity =============================
  viewChatavirsity: function (request, callback) {
    connection.query(
      `SELECT id,image,title,description,price FROM tbl_chatavirsity WHERE is_deleted=0 and id=${request.chatavirsity_id}`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //================ All Faqs =====================================
  allFaqs: function (request, callback) {
    connection.query(
      `SELECT id,question,answer FROM tbl_faqs WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

//=============== Search Faq ===================================
  searchFaq: function (request, callback) {
    // console.log(request);
    connection.query(
      `SELECT id, question,answer FROM tbl_faqs WHERE question LIKE '${
        "%" + request.search + "%"
      }' AND is_active = 1 AND is_deleted = 0 ORDER BY create_at DESC`,
      function (error, result) {
        //console.log(this.sql);
        if (!error && result.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },
  //============== Contact Us =====================================
  contactUs: function (request, callback) {
    var data = {
      user_id: request.user_id,
      full_name: request.fullname,
      phone_number: request.phone_number,
      message: request.description,
    };

    connection.query(
      `INSERT INTO tbl_contact_us SET ?`,
      [data],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //============== search by hashtag ============================
  searchHashTag: function (request, callback) {
    connection.query(
      `SELECT id,firstname,lastname,email,phone_number FROM tbl_contact  WHERE hashtags LIKE '${
        "%" + request.search + "%"
      }' AND is_active=1 AND is_deleted=0 ORDER BY created_at DESC`,
      function (error, result) {
        if (!error && result.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },

  //============= Search Contact =================================
  searchContact: function (request, callback) {
  //  console.log(request);
    connection.query(
      `SELECT id,firstname,lastname,email,phone_number,concat('" ${
        globals.BASE_URL + globals.CONTACT_PROFILE
      }"',profile_image)as profile_image FROM tbl_contact WHERE firstname LIKE '${
        "%" + request.search + "%"
      }' OR lastname LIKE '${
        "%" + request.search + "%"
      }' AND is_active=1 AND is_deleted=0 ORDER BY created_at DESC`,
      function (error, result) {
       // console.log(this.sql);
        if (!error && result.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },

  //============= Search Blog ====================================
  searchBlog: function (request, callback) {
    // console.log(request);
    connection.query(
      `SELECT id, title, description, concat('" ${
        globals.BASE_URL + globals.BLOG_IMAGE
      }"',image)as image FROM tbl_blog WHERE title LIKE '${
        "%" + request.search + "%"
      }' AND is_active = 1 AND is_deleted = 0 ORDER BY created_at DESC`,
      function (error, result) {
        //console.log(this.sql);
        if (!error && result.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },

  //============= search Chatavirsity ============================
  searchChatavirsity: function (request, callback) {
    // console.log(request);
    connection.query(
      `SELECT id, title, description,price, concat('" ${
        globals.BASE_URL + globals.CHATAVIRSITY_IMAGE
      }"',image)as image FROM tbl_chatavirsity WHERE title LIKE '${
        "%" + request.search + "%"
      }' AND is_active = 1 AND is_deleted = 0 ORDER BY create_at DESC`,
      function (error, result) {
        //console.log(this.sql);
        if (!error && result.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },

  //============= Add Daily Plan =================================
  addDailyPlan: function (request, callback) {
    var data = {
      title: request.title,
      user_id: request.user_id,
    };

    connection.query(
      `Insert into tbl_daily_plan set ?`,
      [data],
      function (error, result) {
        //console.log(this.sql);
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },

  //============= daily plan listing ============================
  dailyPlanListing: function (request, callback) {
    connection.query(
      `SELECT id,user_id,title,is_completed FROM tbl_daily_plan WHERE is_deleted=0 AND DATE(created_at) = CURDATE() AND user_id =${request.user_id}`,
      function (error, result) {
        if (!error && result.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },
  
  //============= Delete Daily Plan =============================
   deleteDailyPlan: function (request, callback) {
    connection.query(
      `update tbl_daily_plan set is_deleted ='1' where id=${request.plan_id} AND user_id =${request.user_id} AND is_deleted ='0'`,
      function (error, result) {
        // console.log(this.sql);
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keywords_failed_message", content: {} },
            null
          );
        }
      }
    );
  },

  //============= Edit Daily Plan ==============================
  updateDailyPlan: function (request, callback) {
    connection.query(
      `update tbl_daily_plan set title ='${request.title}' where id=${request.plan_id} AND user_id =${request.user_id} AND is_deleted ='0'`,
      function (error, result) {
        //console.log(this.sql);
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keywords_failed_message", content: {} },
            null
          );
        }
      }
    );
  },
  
  //============= completed Daily Plan ===============================
  completeDailyPlan: function (request, callback) {
  //  console.log(request);
    connection.query(
      `update tbl_daily_plan set is_completed ='${request.is_completed}' where id=${request.plan_id} AND user_id =${request.user_id} AND is_deleted ='0'`,
      function (error, result) {
        //console.log(this.sql);
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keywords_failed_message", content: {} },
            null
          );
        }
      }
    );
  },
  //============ Sheduled listing ================================
  sheduledListing: function (request, callback) {
    connection.query(
      `SELECT sm.id, cn.id, cn.type, cn.firstname, cn.lastname, cn.level, cn.language_id, cn.timezone_id, cn.compnay_name, cn.alternate_email, cn.additional_phone_number,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}', cn.profile_image) AS profile_image
,cn.hashtags, cn.contact_method,cnt.name as contact_type,sm.start_time,sm.end_time, sm.notes as meeting_note,sm.file,sm.create_at AS meeting_created_at FROM tbl_scheduled_meeting sm JOIN tbl_contact cn ON cn.id = sm.contact_id JOIN tbl_contacts_type cnt ON cnt.id = cn.type WHERE DATE(sm.create_at)='${request.date}' AND sm.user_id = ${request.user_id}`,
      function (error, meetings) {
        if (!error) {
          connection.query(
            `SELECT fu.id,cn.type,fu.create_at AS create_at,fu.notes,cn.id,cn.firstname,cn.lastname,cn.level,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}', cn.profile_image) AS profile_image
,cn.language_id,cn.timezone_id,cn.compnay_name,cn.alternate_email,cn.additional_phone_number,cn.hashtags,cn.contact_method,cn.notes,cnt.name AS contact_type from tbl_follow_up fu JOIN tbl_contact cn ON cn.id=fu.contact_id JOIN tbl_contacts_type cnt ON cnt.id=cn.type where cn.is_deleted=0 AND DATE(fu.create_at)='${request.date}' AND fu.user_id=${request.user_id}`,
            function (error, followups) {
              // console.log(this.sql);
              if (!error) {
                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_success", content: {} },
                  { meetings: meetings, followups: followups }
                );
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "rest_keyword_no_data", content: {} },
                  null
                );
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },

  //============ Add chat log ====================================
  addChatlog: function (request, callback) {
    var data = {
      user_id: request.user_id,
      contact_id: request.contact_id,
      file: request.file ? request.file : "",
      notes: request.notes,
    };

    connection.query(
      `Insert into tbl_chat_logs set ?`,
      [data],
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },

  //============ Logged Connections ==============================
  loggedConnections: function (request, callback) {
    //console.log(request.date);
    var date = "";
    if (request.date) {
      date = ` AND DATE(fu.create_at) ='${request.date}'`;
    }

    if (request.filter_no == 1) {
      let followup = `SELECT fu.id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}',c.profile_image) AS profile_image
,DATE_FORMAT(c.created_at, '%d %b, %Y') as contact_create,ct.name as type,fu.create_at as followup_create,fu.date as followup_update FROM tbl_follow_up fu JOIN tbl_contact c ON c.id=fu.contact_id JOIN tbl_contacts_type ct ON ct.id=c.type WHERE fu.is_deleted = 0 AND fu.user_id=${request.user_id} ${date} ORDER BY fu.create_at DESC`;

      connection.query(followup, function (error, followups) {
        //console.log(this.sql);
        if (!error && followups.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            followups
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      });
    } else if (request.filter_no == 2) {
      let meeting = `SELECT fu.id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}', c.profile_image) AS profile_image,DATE_FORMAT(c.created_at, '%d %b, %Y') as created_at,ct.name as type FROM tbl_scheduled_meeting fu JOIN tbl_contact c ON c.id=fu.contact_id JOIN tbl_contacts_type ct ON ct.id=c.type WHERE fu.is_deleted = 0 AND fu.user_id=${request.user_id} ${date} ORDER BY fu.create_at DESC`;
      connection.query(meeting, function (error, meetings) {
        if (request.date) {
          meeting += ` AND DATE(fu.create_at) = ${request.date}`;
        }

        if (!error && meetings.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            meetings
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      });
    } else if (request.filter_no == 3) {
    //console.log(request);
      let followup = `SELECT fu.id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}', c.profile_image) AS profile_image
,DATE_FORMAT(c.created_at, '%d %b, %Y') as created_at,"followup" as type_flag,DATE_FORMAT(fu.create_at,'%d %b, %Y') as followup_create_at,DATE_FORMAT (fu.date,'%d %b,%Y') as followup_update FROM tbl_follow_up fu JOIN tbl_contact c ON c.id=fu.contact_id JOIN tbl_contacts_type ct ON ct.id=c.type WHERE fu.is_deleted = 0 AND fu.user_id=${request.user_id} ${date}  ORDER BY fu.create_at DESC`;

      connection.query(followup, function (error, followups) {
        //console.log(followups);
        let meeting = `SELECT fu.id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}', c.profile_image) AS profile_image
,DATE_FORMAT(c.created_at, '%d %b, %Y') as created_at,"meeting" as type_flag FROM tbl_scheduled_meeting fu JOIN tbl_contact c ON c.id=fu.contact_id JOIN tbl_contacts_type ct ON ct.id=c.type WHERE fu.is_deleted = 0 AND fu.user_id=${request.user_id} ${date} ORDER BY fu.create_at DESC`;
        if (!error) {
        if(followups.length==null){
        connection.query(meeting, function (error, meetings) {
            if (!error && meetings.length > 0) {
              callback(
                globals.SUCCESS,
                { keyword: "rest_keywords_success", content: {} },
                meetings
              );
            } else {
              callback(
                globals.OPRETION_FAILD,
                { keyword: "rest_keyword_no_data", content: {} },
                null
              );
            }
          });
        }else{
           connection.query(meeting, function (error, meetings) {
            if (!error) {
               const combinedArray = [...followups, ...meetings];
              //console.log(followups);
              callback(
                globals.SUCCESS,
                { keyword: "rest_keywords_success", content: {} },
                combinedArray
              );
             } else {
              callback(
                globals.OPRETION_FAILD,
                { keyword: "rest_keyword_no_data", content: {} },
                null
              );
            }
          });
        }
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      });
    } else if (request.filter_no == 0){
      let followup = `SELECT fu.id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}', c.profile_image) AS profile_image
,DATE_FORMAT(fu.create_at, '%d %b, %Y') as created_at,"followup" as type_flag FROM tbl_follow_up fu JOIN tbl_contact c ON c.id=fu.contact_id JOIN tbl_contacts_type ct ON ct.id=c.type WHERE fu.is_deleted = 0 AND fu.user_id=${request.user_id} ${date} ORDER BY fu.create_at DESC`;

 connection.query(followup, function (error, followups) {
 //console.log("done");
          if (!error) {
         let meeting = `SELECT fu.id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}', c.profile_image) AS profile_image
,DATE_FORMAT(fu.create_at, '%d %b, %Y') as created_at,"meeting" as type_flag FROM tbl_scheduled_meeting fu JOIN tbl_contact c ON c.id=fu.contact_id JOIN tbl_contacts_type ct ON ct.id=c.type WHERE fu.is_deleted = 0 AND fu.user_id=${request.user_id} ${date} ORDER BY fu.create_at DESC`;
          connection.query(meeting, function (error, meetings) {
          //console.log(meetings);
            if (!error) {
              if (followups.length === 0 && meetings.length === 0) {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "rest_keyword_no_data", content: {} },
                  null
                );
              } else if (followups.length === 0) {
                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_success", content: {} },
                    meetings
                );
              } else if (meetings.length === 0) {
                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_success", content: {} },
                  followups
                );
              } else {
               const combinedArray = [...followups, ...meetings];
                //{ followups: followups, meetings: meetings }
                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_success", content: {} },
                combinedArray
                );
              }
            } else {
              callback(
                globals.OPRETION_FAILD,
                { keyword: "rest_keyword_no_data", content: {} },
                null
              );
            }
          });

        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      });
    }else
    {
        let followup = `SELECT fu.id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}', c.profile_image) AS profile_image
,DATE_FORMAT(fu.create_at, '%d %b, %Y') as created_at,"followup" as type_flag FROM tbl_follow_up fu JOIN tbl_contact c ON c.id=fu.contact_id JOIN tbl_contacts_type ct ON ct.id=c.type WHERE fu.is_deleted = 0 AND fu.user_id=${request.user_id} ${date} ORDER BY fu.create_at DESC`;

           connection.query(followup, function (error, followups) {
         if (!error) {
         let meeting = `SELECT fu.id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}', c.profile_image) AS profile_image
,DATE_FORMAT(fu.create_at, '%d %b, %Y') as created_at,"meeting" as type_flag FROM tbl_scheduled_meeting fu JOIN tbl_contact c ON c.id=fu.contact_id JOIN tbl_contacts_type ct ON ct.id=c.type WHERE fu.is_deleted = 0 AND fu.user_id=${request.user_id} ${date} ORDER BY fu.create_at DESC`;
          connection.query(meeting, function (error, meetings) {

            if (!error) {
              if (followups.length === 0 && meetings.length === 0) {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "rest_keyword_no_data", content: {} },
                  null
                );
              } else if (followups.length === 0) {
                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_success", content: {} },
                  { meetings: meetings }
                );
              } else if (meetings.length === 0) {
                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_success", content: {} },
                  { followups: followups }
                );
              } else {
               //const combinedArray = [...followups, ...meetings];

                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_success", content: {} },
                { followups: followups, meetings: meetings }
                );
              }
            } else {
              callback(
                globals.OPRETION_FAILD,
                { keyword: "rest_keyword_no_data", content: {} },
                null
              );
            }
          });

        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }); 
    }
  },

  //============ Delete logged ===================================
  deleteLogged: function (request, callback) {
    //console.log(request);
    if (request.label == "meeting") {
      connection.query(
        `UPDATE tbl_scheduled_meeting SET is_deleted="1" WHERE user_id=${request.user_id} AND id=${request.meeting_id} AND contact_id=${request.contact_id}`,
        function (error, result) {
          if (!error) {
            //console.log(this.sql);
            callback(
              globals.SUCCESS,
              { keyword: "rest_keywords_success", content: {} },
              result
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "text_user_something_wrong", content: {} },
              null
            );
          }
        }
      );
    } else if (request.label == "followup") {
      connection.query(
        `UPDATE tbl_follow_up SET is_deleted="1" WHERE user_id=${request.user_id} AND id=${request.followup_id} contact_id=${request.contact_id}`,
        function (error, result) {
          if (!error) {
            callback(
              globals.SUCCESS,
              { keyword: "rest_keywords_success", content: {} },
              result
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "text_user_something_wrong", content: {} },
              null
            );
          }
        }
      );
    } else {
      callback(
        globals.OPRETION_FAILD,
        { keyword: "text_user_something_wrong", content: {} },
        null
      );
    }
  },


  //===================== increase level ==========================
  levelIncrease: function (request, callback) {
    connection.query(
      `SELECT contact_id,CASE WHEN COUNT(contact_id) > 2 THEN 'mediumInterest' WHEN COUNT(contact_id) > 4 THEN 'highInterest' ELSE 'lowInterest' END AS level_text FROM tbl_follow_up WHERE is_deleted = 0 AND contact_id = ${request.contact_id}`,
      function (error, result) {
        if (!error) {
          user.updateLevel(result, function (code, message, data) {
            if (code == 1) {
              callback(
                globals.SUCCESS,
                {
                  keyword: "rest_keywords_success_message",
                  content: {},
                },
                result
              );
            } else {
              callback(
                globals.OPRETION_FAILD,
                { keyword: "text_user_something_wrong", content: {} },
                error
              );
            }
          });
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //======================= update level ==========================
  updateLevel: function (request, callback) {
   // console.log("====", request[0].level_text);
    connection.query(
      `UPDATE tbl_contact SET level ='${request[0].level_text}' WHERE id=${request[0].contact_id}`,
      function (error, result) {
       // console.log(this.sql);
        if (!error) {
          callback(
            globals.SUCCESS,
            {
              keyword: "rest_keywords_success_message",
              content: {},
            },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },
  
   //=========== Complete Followup ================================
  completeFollowup: function (request, callback) {
    // console.log("teamMembers", request);
    connection.query(
      `update tbl_follow_up set is_completed ='${request.is_completed}' where id=${request.followup_id} AND user_id =${request.user_id} AND is_deleted ='0'`,
      function (error, data) {
        // console.log("data", data);
        if (!error && data.length > 0) {
          callback(
            globals.SUCCESS,
            {
              keyword: "rest_keywords_success_message",
              content: {},
            },
            data
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=========== Complete Meeting ================================
  completeMeeting: function (request, callback) {
    // console.log("teamMembers", request);
    connection.query(
      `update tbl_scheduled_meeting set is_completed ='${request.is_completed}' where id=${request.meeting_id} AND user_id =${request.user_id} AND is_deleted ='0'`,
      function (error, data) {
        // console.log("data", data);
        if (!error && data.length > 0) {
          callback(
            globals.SUCCESS,
            {
              keyword: "rest_keywords_success_message",
              content: {},
            },
            data
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },
  
  //======================== Other Teams ===================================================
   otherteams: function (request, callback) {
    connection.query(
      `SELECT t.id as team_id, t.name,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.TEAM_PROFILE}', t.profile_image) as profile_image, u.name as admin, COUNT(tm.id) as members 
        FROM tbl_team t 
        JOIN tbl_user u ON u.id = t.admin_id 
        JOIN tbl_team_members tm ON tm.team_id = t.id 
        WHERE t.is_deleted = 0 
        GROUP BY t.id`,
      function (error, result) {
        if (!error && result.length > 0) {
          asyncLoop(
            result,
            function (item, next) {
              var members = `SELECT t.id, t.admin_id, t.name 
                            FROM tbl_team t 
                            JOIN tbl_team_members tm ON tm.team_id = t.id 
                            WHERE tm.member_id = ? AND t.id = ? AND t.is_deleted = 0`;
              connection.query(
                members,
                [request.user_id, item.team_id],
                function (error, data) {
                  if (!error && data.length > 0) {
                    item.isMember = "1";
                  } else {
                    item.isMember = "0";
                  }
                  next();
                }
              );
            },
            function (error) {
              if (!error) {
                callback(
                  globals.SUCCESS,
                  { keyword: "rest_keywords_success", content: {} },
                  result
                );
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "text_user_something_wrong", content: {} },
                  error
                );
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

    //=========== Team members ==========================================
  teamMembers: function (request, callback) {
    // console.log("teamMembers", request);
    connection.query(
      `SELECT tm.id, tm.team_id, tm.member_id, u.name,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.USER_PROFILE}',u.profile_image) as profile_image,u.created_at FROM tbl_team_members tm JOIN tbl_user u ON u.id = tm.member_id WHERE tm.team_id = ${request.team_id} AND u.is_deleted = 0 AND tm.is_deleted='0'`,
      function (error, data) {
       //console.log("data", data);
        if (!error && data.length > 0) {
          callback(
            globals.SUCCESS,
            {
              keyword: "rest_keywords_success_message",
              content: {},
            },
            data
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },
  
    //=========== Save User Notes =====================================
  userNote: function (request, callback) {
    connection.query(
      `UPDATE tbl_user SET notes='${request.note}' WHERE id=${request.user_id} AND is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            {
              keyword: "rest_keywords_success_message",
              content: {},
            },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //---------------------- User Notes listing ------------------------
  userNoteDetails: function (request, callback) {
    connection.query(
      `select id,notes from tbl_user WHERE id=${request.user_id} AND is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            {
              keyword: "rest_keywords_success_message",
              content: {},
            },
            result[0]
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },
  
  //=========== Save User Notes =====================================
  userNote: function (request, callback) {
    connection.query(
      `UPDATE tbl_user SET notes='${request.note}' WHERE id=${request.user_id} AND is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            {
              keyword: "rest_keywords_success_message",
              content: {},
            },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //---------------------- User Notes listing ------------------------
  userNoteDetails: function (request, callback) {
    connection.query(
      `select id,notes from tbl_user WHERE id=${request.user_id} AND is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            {
              keyword: "rest_keywords_success_message",
              content: {},
            },
            result[0]
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },
  
    //=========== Complete Meeting Notes ==========================
  completeMeetingNote: function (request, callback) {
   //console.log("====", request);
    let data = {
      meeting_completion_notes: request.note,
      meeting_completion_files: request.file ? request.file : null,
    };

    connection.query(
      `update tbl_scheduled_meeting set ? where id=${request.meeting_id} AND is_deleted ='0'`,
      [data],
      function (error, result) {
      // console.log("data", error);
       //console.log(this.sql);
        if (!error) {
          callback(
            globals.SUCCESS,
            {
              keyword: "rest_keywords_success_message",
              content: {},
            },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=========== Complete Followup Notes ==========================
  completeFollowupNote: function (request, callback) {
    //console.log("", request);
    let data = {
      followup_completion_notes: request.note,
      followup_completion_file: request.file ? request.file : null,
    };

    connection.query(
      `update tbl_follow_up set ? where id=${request.followup_id} AND is_deleted ='0'`,
      [data],
      function (error, result) {
        // console.log("data", data);
       // console.log(this.sql);
        if (!error) {
          callback(
            globals.SUCCESS,
            {
              keyword: "rest_keywords_success_message",
              content: {},
            },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },
  
 //====================== Update coantact profile ==================
  updateContactProfile: function (request, callback) {
    connection.query(
      `update tbl_contact set profile_image='${request.profile_image}' WHERE is_deleted = 0 AND id = ${request.contact_id}`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "text_user_something_wrong", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },
  
   //====================== Contact note details ===================
  contactNoteDetails: function (request, callback) {
    connection.query(
      `SELECT id,notes FROM tbl_contact WHERE is_deleted = 0 AND id = ${request.contact_id}`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "text_user_something_wrong", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

 //====================== save contact notes =====================
  saveContactNote: function (request, callback) {
    //console.log(request);
    connection.query(
      `update tbl_contact set notes='${request.note}' WHERE is_deleted = 0 AND id = ${request.contact_id}`,
      function (error, result) {
        //console.log(this.sql);
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "text_user_something_wrong", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
          1;
        }
      }
    );
  },
  
  //=========================== Add Level =================================
  addContactLevel: function (request, callback) {
    var data = {
      level: request.level,
      hashtags: request.hashtags
    };
    connection.query(
      `update tbl_contact set ? WHERE is_deleted = 0 AND id = ${request.contact_id} `,
      [data],
      function (error, result) {
        //console.log(this.sql);
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "text_user_something_wrong", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            null
          );
          1;
        }
      }
    );
  },
  
  //===================== All contact log Notes =============================
  contactLogListing: function (request, callback) {
    //console.log(request);
    connection.query(
      `SELECT id,user_id,contact_id,file,notes,DATE_FORMAT(create_at, '%e %M %Y') as date,DATE_FORMAT(create_at,'%H:%i:%s') as time,"followup" as type FROM tbl_follow_up WHERE is_deleted=0 and contact_id =${request.contact_id}`,
      function (error, followupNotes) {
        //console.log(this.sql);
        if (!error) {
          connection.query(
            `SELECT id,user_id,contact_id,file,notes,DATE_FORMAT(create_at, '%e %M %Y') as date,DATE_FORMAT(create_at,'%H:%i:%s') as time,"meeting" as type FROM tbl_scheduled_meeting WHERE is_deleted=0 and contact_id =${request.contact_id}`,
            function (error, meetingNotes) {
              //console.log(meetingNotes);
              if (!error) {
                connection.query(
                  `SELECT id,user_id,contact_id,file,notes,DATE_FORMAT(created_at, '%e %M %Y') as date,DATE_FORMAT(created_at,'%H:%i:%s') as time,"chatlog" as type FROM tbl_chat_logs WHERE is_deleted=0 and contact_id =${request.contact_id}`,
                  function (error, chatNotes) {
                    // console.log(chatNotes);
                    if (!error) {
                      const data = [
                        ...followupNotes,
                        ...meetingNotes,
                        ...chatNotes,
                      ];
                      callback(
                        globals.SUCCESS,
                        { keyword: "rest_keywords_success", content: {} },
                        data
                      );
                    } else {
                      callback(
                        globals.OPRETION_FAILD,
                        { keyword: "rest_keyword_no_data", content: {} },
                        null
                      );
                    }
                  }
                );
              } else {
                callback(
                  globals.OPRETION_FAILD,
                  { keyword: "rest_keyword_no_data", content: {} },
                  null
                );
              }
            }
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },
  
    //========================== Add Contact Log File ==========================
  addFileContactLog: function (request, callback) {
    if (request.followup_id) {
      connection.query(
        `update tbl_follow_up set file='${request.file}' WHERE is_deleted = 0 AND id = ${request.contact_id} and id=${request.followup_id}`,
        function (error, result) {
          if (!error) {
            callback(
              globals.SUCCESS,
              { keyword: "text_user_something_wrong", content: {} },
              result
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "text_user_something_wrong", content: {} },
              null
            );
          }
        }
      );
    } else if (request.meeting_id) {
      connection.query(
        `update tbl_scheduled_meeting set file='${request.file}' WHERE is_deleted = 0 AND id = ${request.contact_id} and id=${request.meeting_id}`,
        function (error, result) {
          if (!error) {
            callback(
              globals.SUCCESS,
              { keyword: "text_user_something_wrong", content: {} },
              result
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "text_user_something_wrong", content: {} },
              null
            );
          }
        }
      );
    } else {
      connection.query(
        `update tbl_chat_logs set file='${request.file}' WHERE is_deleted = 0 AND id = ${request.contact_id} and id=${request.chatlog_id}`,
        function (error, result) {
          if (!error) {
            callback(
              globals.SUCCESS,
              { keyword: "text_user_something_wrong", content: {} },
              result
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "text_user_something_wrong", content: {} },
              null
            );
          }
        }
      );
    }
  },

  //========================== U[pdate Contact Log File ==========================
  updateNoteContactLog: function (request, callback) {
    if (request.followup_id) {
      connection.query(
        `update tbl_follow_up set notes='${request.note}' WHERE is_deleted = 0 AND contact_id = ${request.contact_id} and id=${request.followup_id}`,
        function (error, result) {
       console.log(this.sql);
          if (!error) {
            callback(
              globals.SUCCESS,
              { keyword: "text_user_something_wrong", content: {} },
              result
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "text_user_something_wrong", content: {} },
              null
            );
          }
        }
      );
    } else if (request.meeting_id) {
      connection.query(
        `update tbl_scheduled_meeting set notes='${request.note}' WHERE is_deleted = 0 AND contact_id = ${request.contact_id} and id=${request.meeting_id}`,
        function (error, result) {
          if (!error) {
            callback(
              globals.SUCCESS,
              { keyword: "text_user_something_wrong", content: {} },
              result
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "text_user_something_wrong", content: {} },
              null
            );
          }
        }
      );
    } else {
      connection.query(
        `update tbl_chat_logs set notes='${request.note}' WHERE is_deleted = 0 AND contact_id = ${request.contact_id} and id=${request.chatlog_id}`,
        function (error, result) {
          if (!error) {
            callback(
              globals.SUCCESS,
              { keyword: "text_user_something_wrong", content: {} },
              result
            );
          } else {
            callback(
              globals.OPRETION_FAILD,
              { keyword: "text_user_something_wrong", content: {} },
              null
            );
          }
        }
      );
    }
  },
  
  //============ contact meeting listing ================================
  contactMeetingListing: function (request, callback) {
    connection.query(
      `SELECT sm.id,sm.notes,sm.file,sm.start_time,sm.end_time,sm.is_completed,sm.meeting_completion_notes,sm.meeting_completion_files,c.id as contact_id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}', c.profile_image) AS profile_image,DATE_FORMAT(sm.updated_at,'%d %M,%Y') as updated_date,DATE_FORMAT(sm.updated_at,'%H:%i:%s') as updated_time FROM tbl_scheduled_meeting sm JOIN tbl_contact c ON c.id=sm.contact_id WHERE sm.is_deleted=0 AND sm.user_id =${request.user_id} AND sm.contact_id=${request.contact_id}`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },

  //============ contact followup listing ================================
  contactFollowupListing: function (request, callback) {
    connection.query(
      `SELECT fu.id,fu.notes,fu.file,fu.is_completed,fu.followup_completion_notes,fu.followup_completion_file,c.id as contact_id,c.firstname,c.lastname,CONCAT('${globals.S3_BUCKET_ROOT}', '${globals.CONTACT_PROFILE}', c.profile_image) AS profile_image,DATE_FORMAT(fu.updated_at,'%d %M %Y') as updated_date,DATE_FORMAT(fu.updated_at,'%H:%i:%s') as updated_time FROM tbl_follow_up fu JOIN tbl_contact c ON c.id=fu.contact_id WHERE fu.is_deleted=0 AND fu.user_id =${request.user_id} AND fu.contact_id=${request.contact_id}`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },
  
   //========== Teammate private note ================================
  teammatePrivateNote: function (request, callback) {
    connection.query(
      `SELECT id,notes,file FROM tbl_user WHERE is_deleted=0 and id=${request.teammate_id}`,
      function (error, result) {
        if (!error && result.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            null
          );
        }
      }
    );
  },
  
  //========= teammate update private note ==========================
  teammatePrivateNoteUpdate: function (request, callback) {
    let data = {
      notes: request.note ? request.note : "",
      file: request.file ? request.file : null,
    };

    connection.query(
      `update tbl_user set ?  WHERE is_deleted=0 and id=${request.teammate_id}`,
      [data],
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            null
          );
        }
      }
    );
  },
  
  
  //=============== Static pages ==========================================
  staticPages: function (request, callback) {
    connection.query(
      `SELECT id,name,content FROM tbl_cms_page WHERE is_active=1 AND is_deleted=0`,
      function (error, result) {
        if (!error && result.length > 0) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },
  
  //=============== Search contact Main seacrch bar =======================
  searchContactMain: function (request, callback) {
    connection.query(
      `SELECT c.id as contact_id,c.firstname,c.lastname,c.compnay_name,c.address,c.email,c.alternate_email,c.phone_number,c.country_code,CONCAT('${globals.S3_BUCKET_ROOT}','${globals.CONTACT_PROFILE}',c.profile_image) profile_image,c.level,c.hashtags,c.contact_method,c.notes FROM tbl_contact c WHERE  c.is_deleted=0 AND (c.firstname LIKE '${"%" + request.search + "%"}' OR c.lastname LIKE '${"%" + request.search + "%"}')`,
      function (error, result) {
        if (!error && result.length > 0) {
            callback(
              globals.SUCCESS,
              { keyword: "rest_keywords_success", content: {} },
              result
            );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "rest_keyword_no_data", content: {} },
            null
          );
        }
      }
    );
  },
   
  //============= Increse descrise Contact count ===========================
  contactCount: function (request, callback) {
    connection.query(
      `update tbl_user set today_contact='${request.count}' WHERE is_deleted = 0 AND id=${request.user_id}`,
      function (error, result) {
        if (!error) {
          callback(
            globals.SUCCESS,
            { keyword: "rest_keywords_success", content: {} },
            result
          );
        } else {
          callback(
            globals.OPRETION_FAILD,
            { keyword: "text_user_something_wrong", content: {} },
            null
          );
        }
      }
    );
  },
};

module.exports = user;
